#include <Xm/MessageB.h>
#include <Xm/SelectioB.h>
#include <Xm/RowColumn.h>
#include <Xm/Frame.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <stdlib.h>
#include "global.h"
#include "messages.h"

void e_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, j, item, imode, sumngroup;
  int           rows, crow, cols, ccol;
  short         is_valid;
  short         *colwidth, *mycolwidth;
  String        *lcol, *lrow;
  String        **cells, *clabels;
  String        **mycells, *myclabels;
  char          buf[100];
  Widget        mbox;
  static Widget dialog, rc, w;
  static Widget var_w, reorder_w;
  Arg           args[5];
  XmStringTable var_list;

  void varname_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void put_to_reorder(Widget widget, XtPointer client_data, XtPointer call_data);
  void put_to_var(Widget widget, XtPointer client_data, XtPointer call_data);
  void reorder_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void showmess(Widget widget, char *title, char *text);
  extern void cancel_cb(Widget, XtPointer, XtPointer);

  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);

  item=(int) client_data;
  switch(item) {
  case 0:      // add observation;
    XtVaGetValues(widget, XmNuserData, &imode, NULL);
    switch(imode) {
    case 1:    // add before current row;
      XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
      XbaeMatrixAddRows(StatData, crow, NULL, NULL,  NULL, 1);
      XbaeMatrixEditCell(StatData, crow, 0);
      lrow=(String *)XtMalloc((rows+1)*sizeof(String));
      for (i=0; i<rows+1; i++) {
	sprintf(buf, "%d", i+1);
	lrow[i]=(String) XtNewString(buf);
      }
      XtVaSetValues(StatData,
		    XmNrowLabelWidth, (short)floor(log10(rows+1))+1,
		    XmNrowLabels, lrow, NULL,
		    NULL);
      sort.nsort=0; sort.ngroup=1; sort.group[0]=rows+1;
      for (i=0; i<rows+1; i++) XtFree(lrow[i]);
      XtFree((char *)lrow);
      break;
    case 2:    // add after current row;
      XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
      XbaeMatrixAddRows(StatData, crow+1, NULL, NULL,  NULL, 1);
      XbaeMatrixEditCell(StatData, crow+1, 0);
      lrow=(String *)XtMalloc((rows+1)*sizeof(String));
      for (i=0; i<rows+1; i++) {
	sprintf(buf, "%d", i+1);
	lrow[i]=(String) XtNewString(buf);
      }
      XtVaSetValues(StatData,
		    XmNrowLabelWidth, (short)floor(log10(rows+1))+1,
		    XmNrowLabels, lrow,
		    NULL);
      sort.nsort=0; sort.ngroup=1; sort.group[0]=rows+1;
      for (i=0; i<rows+1; i++) XtFree(lrow[i]);
      XtFree((char *)lrow);
      break;
    case 3:    // add at the end of the spreadsheet;
      lrow=(String *)XtMalloc(sizeof(String));
      sprintf(buf, "%d", rows+1);
      lrow[0]=(String) XtNewString(buf);
      XbaeMatrixAddRows(StatData, rows, NULL, lrow,  NULL, 1);
      XbaeMatrixEditCell(StatData, rows, 0);
      XtVaSetValues(StatData, XmNrowLabelWidth, (short)floor(log10(rows+1))+1, NULL);
      sort.nsort=0; sort.ngroup=1; sort.group[0]=rows+1;
      XtFree(lrow[0]);
      XtFree((char *) lrow);
      break;
    }
    break;
  case 1:      // add variable;
    XtVaGetValues(widget, XmNuserData, &imode, NULL);
    switch(imode) {
    case 1:  // add before current variable;
      XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
      lcol=(String *)XtMalloc(sizeof(String));
      colwidth=new short [1];
      colwidth[0]=COLWIDTH;
      last_var_num++;
      sprintf(buf, "Var%d", last_var_num);
      lcol[0]=(String) XtNewString(buf);
      XbaeMatrixAddColumns(StatData, ccol, NULL, lcol, colwidth, NULL,  NULL, NULL, NULL, 1);
      XbaeMatrixEditCell(StatData, 0, ccol);
      XbaeMatrixRefresh(StatData);
      for (i=0; i<sort.nsort; i++)
	if (sort.sort[i]>=ccol) sort.sort[i]++;
      for (i=0; i<sort.ndep; i++)
	if (sort.dep[i]>=ccol) sort.dep[i]++;
      delete [] colwidth;
      XtFree(lcol[0]);
      XtFree((char *) lcol);
      break;
    case 2:  // add after current variable;
      XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
      lcol=(String *)XtMalloc(sizeof(String));
      colwidth=new short [1];
      colwidth[0]=COLWIDTH;
      last_var_num++;
      sprintf(buf, "Var%d", last_var_num);
      lcol[0]=(String) XtNewString(buf);
      XbaeMatrixAddColumns(StatData, ccol+1, NULL, lcol, colwidth, NULL,  NULL, NULL, NULL, 1);
      XbaeMatrixEditCell(StatData, 0, ccol+1);
      XbaeMatrixRefresh(StatData);
      for (i=0; i<sort.nsort; i++)
	if (sort.sort[i]>ccol) sort.sort[i]++;
      for (i=0; i<sort.ndep; i++)
	if (sort.dep[i]>ccol) sort.dep[i]++;
      delete [] colwidth;
      XtFree(lcol[0]);
      XtFree((char *) lcol);
      break;
    case 3:  // add at the end of the spreadsheet;
      lcol=(String *)XtMalloc(sizeof(String));
      colwidth=new short [1];
      colwidth[0]=COLWIDTH;
      last_var_num++;
      sprintf(buf, "Var%d", last_var_num);
      lcol[0]=(String) XtNewString(buf);
      XbaeMatrixAddColumns(StatData, cols, NULL, lcol, colwidth, NULL,  NULL, NULL, NULL, 1);
      XbaeMatrixEditCell(StatData, 0, cols);
      delete [] colwidth;
      XtFree(lcol[0]);
      XtFree((char *) lcol);
      break;
    }
    break;
  case 2:      // delete observation;
    if (rows>1) {
      XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
      XbaeMatrixDeleteRows(StatData, crow, 1);
      rows--;
      /* correct row labels */
      lrow=(String *)XtMalloc(rows * sizeof(String));
      for (i=0; i<rows; i++) {
	sprintf(buf, "%d", i+1);
	lrow[i]=(String) XtNewString(buf);
      }
      XtVaSetValues(StatData, XmNrowLabels, lrow, NULL);
      for (i=0; i<rows; i++) XtFree(lrow[i]);
      XtFree((char *) lrow);
      /* set edit cell */
      if (rows-1>= crow) XbaeMatrixEditCell(StatData, crow, ccol);
      else XbaeMatrixEditCell(StatData, crow-1, ccol);
      XbaeMatrixRefresh(StatData);
      /* correct sort.group structure */
      if (sort.ngroup==1) sort.group[0]=rows;
      else {
	sumngroup=0;
	for (i=0; i<sort.ngroup; i++) {
	  if (crow>=sumngroup && crow<(sumngroup+sort.group[i])) {
	    sort.group[i]--;
	    if (sort.group[i]==0) {
	      for (j=i; j<(sort.ngroup-1); j++) sort.group[j]=sort.group[j+1];
	      sort.ngroup--; sumngroup++;
	      sort.group=(int *)realloc(sort.group, sort.ngroup*sizeof(int));
	    }
	  }
	  if (i<sort.ngroup) sumngroup+=sort.group[i];
	}
      }
    }
    else {
      // Report error;
      showmess(StatData, "Error", "Use File/Close to get rid of the spreadsheet!");
    }
    break;
  case 3:      // delete variable;
    if (cols>1) {
      XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
      for (i=0; i<sort.nsort; i++) {
	if (sort.sort[i]==ccol) {
	  sort.del(i);
	  i--;
	}
	else if (sort.sort[i]>ccol) sort.sort[i]--;
      }
      for (i=0; i<sort.ndep; i++) {
	if (sort.dep[i]==ccol) {
	  sort.deldep(i);
	  i--;
	}
	else if (sort.dep[i]>ccol)  sort.dep[i]--;
      }
      XbaeMatrixDeleteColumns(StatData, ccol, 1);
      cols--;
      if (cols-1>= ccol) XbaeMatrixEditCell(StatData, crow, ccol);
      else XbaeMatrixEditCell(StatData, crow, ccol-1);
      XbaeMatrixRefresh(StatData);
    }
    else {
      // Report error;
      showmess(StatData, "Error", "Use File/Close to get rid of the spreadsheet!");
    }
    break;
  case 4:     // change variable name;
    XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
    XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
    i=0;
    XtSetArg(args[i], XmNselectionLabelString, XmStringCreateLocalized("Enter Variable Name: ")); i++;
    XtSetArg(args[i], XmNtitle, "Variable Name"); i++;
    XtSetArg(args[i], XmNautoUnmanage, False); i++;
    mbox=XmCreatePromptDialog(StatData, "varname", args, i);
    XtVaSetValues(mbox, XmNtextString, XmStringCreateLocalized(lcol[ccol]), NULL);
    XtAddCallback(mbox, XmNokCallback, varname_cb, NULL);
    XtAddCallback(mbox, XmNcancelCallback, cancel_cb, NULL);
    XtUnmanageChild(XmSelectionBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
    XtManageChild(mbox);
    XtPopup(XtParent(mbox), XtGrabNone);
    break;
  case 5:      // change variable order;
    XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
    i=0;
    XtSetArg(args[i], XmNdialogTitle,
	     XmStringCreateLocalized("Change Variable Order")); i++;
    XtSetArg(args[i], XmNmessageString,
	     XmStringCreateLocalized("Choose Order of Variables:")); i++;
    if (!dialog) {
      dialog=XmCreateMessageDialog(StatData, "varorderdialog", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));
      XtVaSetValues(dialog, XmNheight, 350, NULL);
      rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, dialog,
			  XmNorientation, XmHORIZONTAL,
			  NULL);
      w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				XmNshadowType, XmSHADOW_OUT,
				NULL);
      XtVaCreateManagedWidget("list of variables", xmLabelGadgetClass, w,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      var_w=XmCreateScrolledList(w, "varlist", NULL, 0);
      XtVaSetValues(var_w,
		    XmNchildType, XmFRAME_WORKAREA_CHILD,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    NULL);
      XtManageChild(var_w);
      w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				XmNshadowType, XmSHADOW_OUT,
				NULL);
      XtVaCreateManagedWidget("reordered variables", xmLabelGadgetClass, w,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      reorder_w=XmCreateScrolledList(w,"reorderlist", NULL, 0);
      XtVaSetValues(reorder_w,
		    XmNchildType, XmFRAME_WORKAREA_CHILD,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    NULL);
      XtManageChild(reorder_w);
      XtManageChild(rc);
      XtVaSetValues(dialog, XmNuserData, reorder_w, NULL);
      XtAddCallback(var_w, XmNsingleSelectionCallback, put_to_reorder, reorder_w);
      XtAddCallback(reorder_w, XmNsingleSelectionCallback, put_to_var, var_w);
      XtAddCallback(dialog, XmNokCallback, reorder_ok_cb, var_w);
    }
    /* create var-list */
    var_list=(XmStringTable) XtMalloc (cols * sizeof(XmString));
    for (i=0; i<cols; i++) var_list[i]=XmStringCreateLocalized(lcol[i]);
    XtVaSetValues(var_w,
		  XmNitemCount, cols,
		  XmNitems, var_list,
		  NULL);
    XmListDeleteAllItems(reorder_w);
    XtManageChild(dialog);
    XtPopup(XtParent(dialog), XtGrabNone);
    for (i=0; i<cols; i++) XmStringFree(var_list[i]);
    XtFree((char *)var_list);
    break;
  case 6: /* copy column */
    XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
    XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
    XtVaGetValues(StatData, XmNcells, &cells, NULL);
    XtVaGetValues(StatData, XmNcolumnWidths, &colwidth, NULL);
    mycolwidth=new short[1];
    mycolwidth[0]=colwidth[ccol];
    myclabels=new String[1];
    strcpy(buf, clabels[ccol]); strcat(buf, "_");
    is_valid=0;
    while(!is_valid) {
      strcat(buf, "c");
      is_valid=1;
      for (i=0; i<cols; i++)
	if(!strcmp(clabels[i], buf)) is_valid=0;
    }
    myclabels[0]=(String) XtNewString(buf);
    mycells=new String*[1];
    mycells[0]=new String[rows];
    for (i=0; i<rows; i++) mycells[0][i]=(String)XtNewString(cells[i][ccol]);
    XbaeMatrixAddColumns(StatData, ccol+1, *mycells, myclabels, mycolwidth, NULL, NULL, NULL, NULL, 1);
    XbaeMatrixEditCell(StatData, crow, ccol+1);
    XbaeMatrixRefresh(StatData);
    delete[]mycolwidth;
    XtFree(myclabels[0]);
    delete[]myclabels;
    for (i=0; i<rows; i++) XtFree(mycells[0][i]);
    delete[]mycells[0]; delete[]mycells;
    break;
  case 7: /* copy row */
    XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
    XtVaGetValues(StatData, XmNcells, &cells, NULL);
    mycells=new String*[1];
    mycells[0]=new String[cols];
    for (i=0; i<cols; i++) mycells[0][i]=(String)XtNewString(cells[crow][i]);
    XbaeMatrixAddRows(StatData, crow+1, *mycells, NULL, NULL, 1);
    lrow=(String *)XtMalloc((rows+1)*sizeof(String));
    for (i=0; i<rows+1; i++) {
      sprintf(buf, "%d", i+1);
      lrow[i]=(String) XtNewString(buf);
    }
    XtVaSetValues(StatData,
		  XmNrowLabelWidth, (short)floor(log10(rows+1))+1,
		  XmNrowLabels, lrow,
		  NULL);
    XbaeMatrixEditCell(StatData, crow+1, ccol);
    XbaeMatrixRefresh(StatData);
    sort.nsort=0; sort.ngroup=1; sort.group[0]=rows+1;
    for (i=0; i<cols; i++) XtFree(mycells[0][i]);
    delete[]mycells[0]; delete[]mycells;
    for (i=0; i<rows+1; i++) XtFree(lrow[i]);
    XtFree((char *)lrow);
    break;
  }
}


/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

void varname_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int                          i, crow, ccol, cols;
  short                        is_invalid;
  XmSelectionBoxCallbackStruct *cbs=(XmSelectionBoxCallbackStruct *) call_data;
  String                       *lcolnew, *lcolold;
  char                         *text;

  extern void showmess(Widget widget, char *title, char *text);

  XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &text);
  XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &lcolold, NULL);
  /* test whether new name already exists */
  is_invalid=0;
  for (i=0; i<cols; i++)
    if (i!=ccol)
      if (!strcmp(lcolold[i], text)) is_invalid=1;
  /* generate a new list of variable names */
  if (!is_invalid) {
    lcolnew=(String *)XtMalloc(cols * sizeof(String));
    for (i=0; i<cols; i++) {
      if (i!=ccol) lcolnew[i]=(String) XtNewString(lcolold[i]);
      else         lcolnew[i]=(String) XtNewString(text);
    }
    XtVaSetValues(StatData, XmNcolumnLabels, lcolnew, NULL);
    for (i=0; i<cols; i++) XtFree(lcolnew[i]);
    XtFree((char *) lcolnew);
    XtUnmanageChild(widget);
  }
  else showmess(widget, VARNAME_T, VARNAME_M);

  XtFree(text);
}

void put_to_reorder(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               reorder_w;
  XmListCallbackStruct *cbs;

  reorder_w=(Widget) client_data;
  cbs      =(XmListCallbackStruct *) call_data;
  
  XmListAddItem(reorder_w, cbs->item, 0);
  XmListDeletePos(widget, cbs->item_position);
}

void put_to_var(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               var_w;
  XmListCallbackStruct *cbs;

  var_w=(Widget) client_data;
  cbs      =(XmListCallbackStruct *) call_data;
  
  XmListAddItem(var_w, cbs->item, 0);
  XmListDeletePos(widget, cbs->item_position);
}

void reorder_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int            i, j, k, cols, ccol, crow, nvar, nreorder;
  Widget         reorder_w, var_w;
  XmStringTable  reorder_l, var_l;
  String         *lcol;
  char           *text;

  void change_cols(Widget StatData, int pos1, int pos2);

  var_w = (Widget) client_data;
  XtVaGetValues(widget, XmNuserData, &reorder_w, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
  XtVaGetValues(reorder_w, XmNitemCount, &nreorder, NULL);
  XtVaGetValues(reorder_w, XmNitems, &reorder_l, NULL);
  XtVaGetValues(var_w, XmNitemCount, &nvar, NULL);
  XtVaGetValues(var_w, XmNitems, &var_l, NULL);
  XbaeMatrixGetCurrentCell(StatData, &crow, &ccol);

  /* first sort according to the reorder list */
  for (i=0; i<nreorder; i++) {
    XmStringGetLtoR(reorder_l[i], XmFONTLIST_DEFAULT_TAG, &text);
    for (j=i+1; j<cols; j++) {
      if (!strcmp(text, lcol[j])) {
	/* exchange variable i with variable j */
	change_cols(StatData, i, j);
	XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
	/* correct current cell */
	if (i==ccol) ccol=j;
	/* correct sort and dep variables */
	for (k=0; k<sort.nsort; k++) {
	  if (i==sort.sort[k]) sort.sort[k]=j; 
	  else if (j==sort.sort[k]) sort.sort[k]=i;
	}
	for (k=0; k<sort.ndep; k++) {
	  if (i==sort.dep[k]) sort.dep[k]=j;
	  else if (j==sort.dep[k]) sort.dep[k]=i;
	}
      }
    }
    XtFree(text);
  }

  /* then sort according to the var list */
  for (i=nreorder; i<nvar+nreorder; i++) {
    XmStringGetLtoR(var_l[i-nreorder], XmFONTLIST_DEFAULT_TAG, &text);
    for (j=i+1; j<cols; j++) {
      if (!strcmp(text, lcol[j])) {
	/* exchange variable i with variable j */
	change_cols(StatData, i, j);
	XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
	/* correct current cell */
	if (i==ccol) ccol=j;
	/* correct sort and dep variables */
	 for (k=0; k<sort.nsort; k++) {
	  if (j==sort.sort[k]) sort.sort[k]=i;
	  else if (i==sort.sort[k]) sort.sort[k]=j;
	}
	for (k=0; k<sort.ndep; k++) {
	  if (j==sort.dep[k]) sort.dep[k]=i;
	  else if (i==sort.dep[k]) sort.dep[k]=j;
	} 
      } 
    }
    XtFree(text);
  }
  XbaeMatrixCancelEdit(StatData, False);
  XbaeMatrixEditCell(StatData, crow, ccol);
  XbaeMatrixRefresh(StatData);
}


void change_cols(Widget widget, int pos1, int pos2) {
  int    rows, cols, i;
  String **cells, dcells;
  String *lcolnew, *lcolold;

  XtVaGetValues(widget, XmNrows, &rows, NULL);
  XtVaGetValues(widget, XmNcolumns, &cols, NULL);
  XtVaGetValues(widget, XmNcells, &cells, NULL);
  /* exchange cells of all rows */
  for (i=0; i<rows; i++) {
    dcells=cells[i][pos1];
    cells[i][pos1]=cells[i][pos2];
    cells[i][pos2]=dcells;
  }
  /* exchange labels */
  XtVaGetValues(widget, XmNcolumnLabels, &lcolold, NULL);
  lcolnew=(String *)XtMalloc(cols * sizeof(String));
  for (i=0; i<cols; i++) {
    if (i==pos1) lcolnew[i]=(String) XtNewString(lcolold[pos2]);
    else if (i==pos2) lcolnew[i]=(String) XtNewString(lcolold[pos1]);
    else lcolnew[i]=(String) XtNewString(lcolold[i]);
  }
  XtVaSetValues(widget, XmNcolumnLabels, lcolnew, NULL);
  for (i=0; i<cols; i++) XtFree(lcolnew[i]);
  XtFree((char *) lcolnew);
}
